/**************************************************************************
 *   MudClient - cmd.c                                                    *
 *   Copyright (C) 1997  Christophe Roux                                  *
 *   This program is free software; you can redistribute it and/or modify *
 *   it under the terms of the GNU General Public License as published by *
 *   the Free Software Foundation; either version 1, or (at your option)  *
 *   any later version.                                                   *
 *                                                                        *
 *   This program is distributed in the hope that it will be useful,      *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 *   GNU General Public License for more details.                         *
 *                                                                        *
 *   You should have received a copy of the GNU General Public License    *
 *   along with this program; if not, write to the Free Software          *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.            *
 *                                                                        *
 **************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include "alias.h"
#include "cmd.h"
#include "help.h"
#include "mudcl.h"

extern int conn;

struct
{
  char *cmd;
  void (*action)(char *param);
} tab_cmd[] =
{
  { "alias"   , add_alias   },
  { "alist"   , list_alias  },
  { "help"    , help        },
  { "load"    , load_alias  },
  { "save"    , save_alias  },
  { "unalias" , rm_alias    },
  { NULL      , NULL        }
};

int is_cmd(char *line,int sock)
{
  char *cmd,*param;
  int pos_cmd;

  if (*line != CMD_CHAR)
    return 0;
  if (*(line + 1) == CMD_CHAR)
  {
    if ((int) write(sock,line + 2,strlen(line + 2)) < 0)
      conn=0;
    return 1;
  }
  cmd = ++line;
  param = line;
  while ((*param != '\0') && (*param != ' '))
    param++;
  if (*param)
  {
    *param = '\0';
    param++;
    while(*param == ' ')
      param++;
  }
  for (pos_cmd = 0 ; tab_cmd[pos_cmd].cmd ; pos_cmd++)
  {
    if (!strcmp(tab_cmd[pos_cmd].cmd,cmd))
    {
      tab_cmd[pos_cmd].action(param);
      return 1;
    }
  }
  putscr("\n*** Error : %s is not a command\n",cmd);
  return 0;
}

int mudclrc(int sock)
{
  char str[STR_SIZE];
  FILE *stream;
  int lineno;

  lineno = 0;
  sprintf(str,"%s/.mudclrc",getenv("HOME"));
  stream = fopen(str,"r");
  if (!stream)
    return 0;
  while (!feof(stream))
  {
    fgets(str,STR_SIZE,stream);
    if (!feof(stream))
    {
      lineno++;
      if (*str == CMD_CHAR)
      {
	if (str[strlen(str) - 1] == '\n')
	  str[strlen(str) - 1] = '\0';
	if (!is_cmd(str,sock))
	{
	  putscr("\n*** Error in ~/.mudclrc at line %d\n",lineno);
	}
      }
      else
	putscr("\n*** Error in ~/.mudclrc at line %d\n",lineno);
    }
  }
  fclose(stream);
  return 1;
}
